{ config, lib, ... }:

with lib;

let
  cfg = config.settings.containers.caddy;
in {
  options = {
    settings.containers.caddy.enable = lib.mkOption {
      type = lib.types.bool;
      default = false;
      description = ''
        Enable caddy container
      '';
    };
  };

  config = mkIf cfg.enable {
    services.podman.containers.caddy = {
      image = "ghcr.io/iarekylew00t/caddy-cloudflare:latest";
      ports = [
        "1080:80"
        "1443:8443"
      ];
      volumes = [
        "/home/deploy/containers/caddy/Caddyfile:/etc/caddy/Caddyfile:Z"
      ];
    };

    home.file."containers/caddy/Caddyfile".text = ''
      http://localhost {
        respond "Hello there"
      }
    '';
  };
}
